local mouse_was_down = false
----------------------------------------------------------  BUTTONS ----------------------------------------------

function isPointInRect (x1, y1, x2, y2, px, py)
	if (px > x1 and px < x2 and py > y1 and py < y2) then return true end
	return false
end


function drawButtons (b)
	--font:setLineHeight (1.0)
	love.graphics.setFont(gFont.small)

	local mousex, mousey = TLfres.getMousePosition(res_w,res_h) --love.mouse.getPosition()
	for i = 1, #b, 1 do
		if not b[i].hidden then 
			--love.graphics.print(b[i].text, b[i].x+10, b[i].y+b[i].h-5) --0.6.2
			if (isPointInRect (b[i].x, b[i].y, b[i].x+b[i].w, b[i].y+b[i].h,  mousex, mousey) or i == active_button) then
				--highlighted button
				love.graphics.setColor(0, 0.5, 0, 1)
				love.graphics.rectangle ("fill", b[i].x, b[i].y, b[i].w, b[i].h)
				love.graphics.setColor(1, 1, 0, 1)
				love.graphics.rectangle ("fill", b[i].x, b[i].y, 10, b[i].h)		
				love.graphics.rectangle ("line", b[i].x+2, b[i].y+2, b[i].w-2, b[i].h-2)
			else --unactive button
				love.graphics.setColor(0.1, 0.7, 0.1, 1)
				love.graphics.rectangle ("line", b[i].x, b[i].y, b[i].w, b[i].h)
			end
		local s = b[i].text
		if b[i].toggle_i then
			s = s .. b[i].toggles[b[i].toggle_i]
			--love.graphics.print("toggle_i:"..b[i].toggle_i, b[i].x-10, b[i].y)
		end
		love.graphics.setColor(0, 1, 0, 1)
		love.graphics.print(s, b[i].x+10, b[i].y) --0.7.2
	end
	end
end

function addButton (buttonlist, x,y, w, h, text, name, toggles, defaulttogglei)
	if (h == nil) then h = 20 end
	--h = 25
	local new_button = {}
	new_button.x=x new_button.y=y new_button.w=w new_button.h=h new_button.text=text new_button.name=name
	if toggles then		
		new_button.toggles = shallowcopy(toggles)		
		new_button.toggle_i = defaulttogglei or 1
		new_button.toggle_s = toggles[new_button.toggle_i]		
	end
	table.insert (buttonlist, new_button)
	return #buttonlist
end

function previous_button ()
	active_button = active_button -1
	if (active_button < 1) then active_button = #buttons end
end

function next_button ()
	active_button = active_button +1
	if (active_button > #buttons) then active_button = 1 end
end

--b: buttonsList to check for clicks. returns name & index of clicked button
function clickedButton (b)
	local mousex, mousey = TLfres.getMousePosition(res_w,res_h) --love.mouse.getPosition()
	local click = love.mouse.isDown(1)
	local CBi = nil
	--if (mouse_was_down==false and click == false) then return "NOBUTTONCLICKED" end
	for i = 1, #b, 1 do	
			if not b[i].hidden then
			if (mouse_was_down and click == false and isPointInRect (b[i].x, b[i].y, b[i].x+b[i].w, b[i].y+b[i].h,  mousex, mousey)) then
			
			mouse_was_down=false
			CBi = i
			break
			end
			if (mouse_was_down == false and click == true and isPointInRect (b[i].x, b[i].y, b[i].x+b[i].w, b[i].y+b[i].h,  mousex, mousey)) then mouse_was_down = true end
			end
		end
	--keyboard:
	if (enter_was_down and active_button > 0 and active_button < #buttons+1) then 
		enter_was_down = false		 
		if not b[active_button].hidden then CBi = active_button end
	end
	
	if CBi then
		if b[CBi].toggle_i then
			b[CBi].toggle_i=b[CBi].toggle_i+1
			if (b[CBi].toggle_i > #b[CBi].toggles) then b[CBi].toggle_i = 1 end
			b[CBi].toggle_s = b[CBi].toggles[b[CBi].toggle_i]
		end
		return b[CBi].name, CBi
	end	
	return "NOBUTTONCLICKED"
end


function buttoni_from_name (b, buttonname)
	for i = 1, #b, 1 do
		if buttonname == b[i].name then return i end
	end
end

-----buttons end----
