-----view start
--viewHeight=res_h/4
--viewWidth=res_w/4

--view {} --.canvas --cameraX, cameraY
splitScreen = false
function newView (canvasWidth, canvasHeight, viewName)
	local v = {
	canvas = love.graphics.newCanvas(canvasWidth, canvasHeight),
	canvasWidth = canvasWidth,
	canvasHeight = canvasHeight,
	viewName = viewName,
	cameraX = 400,
	cameraY = 300
	}
	return v
end

function showView (view,x,y, title)
	LG.setColor(1, 1, 1, 1)	
	LG.setLineWidth (2)
	LG.rectangle('line', x, y, view.canvasWidth, view.canvasHeight) --frame
	LG.setColor(0, 0, 0, 1)
	LG.rectangle('fill', x, y, view.canvasWidth, view.canvasHeight) --background
	LG.setBlendMode("alpha", "premultiplied")
	LG.setColor(1, 1, 1, 1)

	LG.draw (view.canvas,x,y)
	LG.setBlendMode("alpha")
	LG.print ("title:" .. title, x,y)
	LG.print ("viewName:"..view.viewName .. " cameraX/Y="
	..(view.cameraX or "nil") .."/".. (view.cameraY or "nil"), x,y+view.canvasHeight)

end

function drawView (view)
	LG.push ()
	LG.origin ()
	LG.setCanvas(view.canvas)
	LG.clear ()
	if view.viewName == "mouseView" then LG.scale (0.5,0.5) end
	--white testcircles to mark top-left and bottom-right corner of view-window
	LG.setColor(1, 1, 1, 1)	
	LG.circle("fill", 0,0, 20, 6)
	LG.circle("fill", view.canvasWidth,view.canvasHeight, 20, 6)
	--drawing actual content of view-window
	--LG.setColor(0, 0, 1, 1)
--	LG.circle("fill", math.random(0,view.canvasWidth), math.random(0,view.canvasHeight), 20, 5)
--	love.graphics.setColor(1, 0, 0, 1)
--	LG.circle("fill", math.random(0,view.canvasWidth), math.random(0,view.canvasHeight), 20, 5)

	LG.translate (-view.cameraX + view.canvasWidth/2, -view.cameraY + view.canvasHeight/2)
   	drawLevel ()
	drawPlayers ()
	LG.pop ()
	LG.setCanvas()
end
----view end


function ingameDraw ()
	
   	LG.setFont (gFont.small)
	
   	drawLevel ()
   	printAllPlayers (800,20)
   	drawPlayers ()
   	
   	if splitScreen then
		drawView(view1)
		drawView(view2)
		drawView(mouseView)

		showView(view1, 50+gt*10,500, "player 1 ONE")
		showView(view2, 50,100, "player 2 TWO")
		showView(mouseView, 400,200, "look at mouse")
	end
	
	love.graphics.print("ig_draw() gt:"..gt, 10, 30)
   	love.graphics.print("ig_draw() gbla:"..gbla, 10, 50)
end

function ingameUpdate (dt)
	gbla=math.random(100)
	getPlayersInputs()
	updatePlayersPhysics (dt)
	view1.cameraX = gplayers[1].x
	view1.cameraY = gplayers[1].y
	view2.cameraX = gplayers[2].x+math.sin (gt)*50
	view2.cameraY = gplayers[2].y+math.cos (gt)*50
	local mx,my = TLfres.getMousePosition(res_w,res_h)
	mouseView.cameraX=mx
	mouseView.cameraY=my
end

function ingameKeyPressed (key, unicode)
	if key == "escape" then changeGameStatus ("menu") end
	if key == "space" then splitScreen = not splitScreen end
end

function updatePlayersPhysics (dt)
	local speed = 100
	for i,p in ipairs(gplayers) do
		if p.wantLeft then p.x = p.x -speed*dt end
		if p.wantRight then p.x = p.x +speed*dt end
		if p.wantUp then p.y = p.y -speed*dt end
		if p.wantDown then p.y = p.y +speed*dt end
	end
end


function loadLevel (levelnumber)
	levelData = "xxx xxx"
	level = {}
	level.trees = {}
	for i = 1, 2000 do
		level.trees[i]= {x=math.random(0,5000), y=math.random (0,5000), size = math.random (10,50)}
	end
end

function drawLevel ()
	for x = 1, 2000, 100 do  --TEST
		for y = 0, 2000, 100 do
			if (x+y*(x+y*2))%3 < 2 then LG.setColor (0.5,0.5,0.5,1) else
				LG.setColor (0,0.2,0.5,1)
				end
			LG.rectangle ("fill", x,y, 100,100)
		end
	end

	for i =1, #level.trees do
		drawTree (level.trees[i].x, level.trees[i].y, level.trees[i].size)
	end
	local mx,my = TLfres.getMousePosition(res_w,res_h)
	LG.setColor (1,1,0,1)
	for r = 10, 10+math.abs(math.sin (gt*10))*50, 10 do
	LG.circle ("line", mx,my, r, 8)
	end
end

function drawTree (x,y,size)
	LG.setColor(0, 1, 0, 1)	
	LG.circle("fill", x,y, size, 3)
end

function drawPlayers ()
	LG.setColor(1, 1, 0, 1)
	LG.print ("drawPlayers()",500,20)

	for i,p in ipairs(gplayers) do
			--	LG.circle("fill", 500,50+i*50, 100, 4)
LG.setColor(1, 1, 1, 1)
			LG.circle("fill", p.x,p.y, 25, 4)
			LG.setColor(1, 0, 0, 1)

			LG.print ("player"..i,p.x,p.y)
			LG.print ("player iXY:" .. i.." / ".. p.x.." / ".. p.y, 500,50+i*20)

	end
end
