
function getPlayersInputs ()
	for i,p in ipairs(gplayers) do
		p.wantLeft, p.wantRight, p.wantUp, p.wantDown, p.wantShot = false,false,false,false,false
		--keyboard
		if LKB.isDown(p.keyLeft) then p.wantLeft = true end
		if LKB.isDown(p.keyRight) then p.wantRight = true end
		if LKB.isDown(p.keyUp) then p.wantUp = true end
		if LKB.isDown(p.keyDown) then p.wantDown = true end
		if LKB.isDown(p.keyShot) then p.wantShot = true end
		--gamepad
		--TODO
	end
end

function addPlayer (keyLeft,keyRight,keyUp,keyDown,keyShot)
	local newPlayer = {isActive = true, 
	keyLeft = keyLeft or "a",
	keyRight = keyRight or "d",
	keyUp = keyUp or "w",
	keyDown = keyDown or "s",
	keyShot = keyShot or "x",	
	wantLeft=false,wantRight=false,wantUp=false,wantShot=false,
	joystick = nil, --joystick-object
	joysticki = nil, --joystick-index
	x = 600,	--FIXME: player should not have x,y coordinates, health etc.
	y = 500,	--		 instead player will just be the controller and control "units" or "objects"
	}
	table.insert (gplayers, newPlayer)
end

--debug/test functions:
function printPlayerWant (p,x,y)
	local bs = {[true]="x", [false]="-"}
	local x=x or 400
	local y=y or 200
	LG.print("<>^vS", x, y)
	LG.print (bs[p.wantLeft]..bs[p.wantRight]..bs[p.wantUp]..bs[p.wantDown]..bs[p.wantShot], x, y+15)
end

function printAllPlayers (x,y)
	LG.setFont (gFont.small)
	local x=x or 500
	local y=y or 500
	for i,p in ipairs(gplayers) do
		LG.print ("player #"..i,x,y)
		printPlayerWant (p, x,y+30)
		y=y+60
	end
end
